//
//  UINavigationBar+WHBKNavBar.m
//  NavigationTool
//
//  Created by paykee on 16/6/18.
//  Copyright © 2016年 jpy. All rights reserved.
//

#import "UINavigationBar+WHBKNavBar.h"

@implementation UINavigationBar (WHBKNavBar)

static NSString *navBackViewName;

//动态添加属性
-(UIView *)navBackView{
    //获取关联对象
    return objc_getAssociatedObject(self, &navBackViewName);
}

-(void)setNavBackView:(UIView *)navBackView{
    //设置关联对象
    objc_setAssociatedObject(self, &navBackViewName, navBackView, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

/**
 *  设置导航栏的属性，所谓的设置实质就是替换，盖一张View在导航栏最上层
 *
 *  @param navBarBackgroundColor  导航栏的背景颜色
 *  @param titleAttribute         导航栏标题的属性
 *  @param barButtonItemAttribute 导航栏BtnItem的属性
 */
-(void)setNavBarBackgroundColor:(UIColor *)navBarBackgroundColor andTitleAttribute:(NSDictionary *)titleAttribute andBarButtonItemAttribute:(NSDictionary *)barButtonItemAttribute{
    if(!self.navBackView){
        [self setBackgroundImage:[UIImage new] forBarMetrics:UIBarMetricsDefault];
        self.navBackView = [[UIView alloc] initWithFrame:CGRectMake(0, -20, [UIScreen mainScreen].bounds.size.width, CGRectGetHeight(self.bounds) + 20)];
        [self setTitleTextAttributes:titleAttribute];
        UIBarButtonItem *appearance = [UIBarButtonItem appearance];
        [appearance setTitleTextAttributes:barButtonItemAttribute forState:UIControlStateNormal];
        [self insertSubview:self.navBackView atIndex:0];
        [self setShadowImage:[UIImage new]];
    }
    self.navBackView.backgroundColor = navBarBackgroundColor;
}


@end
