//
//  WHBKHelpNaviController.h
//  NavigationTool
//
//  Created by paykee on 16/6/18.
//  Copyright © 2016年 jpy. All rights reserved.
//

#import <UIKit/UIKit.h>

@interface WHBKHelpNaviController : UINavigationController

///**
// *  不带透明过度的导航控制器(不使用运行时机制)
// *
// *  @param rootViewController     根控制器
// *  @param backgroundColor        导航栏背景色
// *  @param titileStr              导航栏的标题名称
// *  @param barButtonItemAttribute 导航栏barItem按钮的属性
// *  @param barTitleAttribute      导航栏标题的属性
// */
//-(instancetype)initNoTransparentOverWithRootViewController:(UIViewController *)rootViewController andNaviBackgroundColor:(UIColor *)backgroundColor andTitle:(NSString *)titileStr andBarButtonItemAttribute:(NSDictionary *)barButtonItemAttribute andBarTitleAttribute:(NSDictionary *)barTitleAttribute;


/**
 *  不带透明过度的导航控制器(使用运行时机制)，各种人习惯而定
 *
 *  @param rootViewController     根控制器
 *  @param backgroundColor        导航栏背景色
 *  @param titileStr              导航栏的标题名称
 *  @param barButtonItemAttribute 导航栏barItem按钮的属性
 *  @param barTitleAttribute      导航栏标题的属性
 */
-(instancetype)initNoTransparentOverWithRootViewController:(UIViewController *)rootViewController andNaviBackgroundColor:(UIColor *)backgroundColor andTitle:(NSString *)titileStr andBarButtonItemAttribute:(NSDictionary *)barButtonItemAttribute andBarTitleAttribute:(NSDictionary *)barTitleAttribute;



/**
 *  带透明过度的导航控制器
 *
 *  @param rootViewController     根控制器
 *  @param backgroundColor        导航栏背景色
 *  @param titileStr              导航栏的标题名称
 *  @param barButtonItemAttribute 导航栏barItem按钮的属性
 *  @param barTitleAttribute      导航栏标题的属性
 */
-(instancetype)initTransparentOverithRootViewController:(UIViewController *)rootViewController andNaviBackgroundColor:(UIColor *)backgroundColor andTitle:(NSString *)titileStr andBarButtonItemAttribute:(NSDictionary *)barButtonItemAttribute andBarTitleAttribute:(NSDictionary *)barTitleAttribute;

@end
