//
//  WHBKHelpNaviController.m
//  NavigationTool
//
//  Created by paykee on 16/6/18.
//  Copyright © 2016年 jpy. All rights reserved.
//

#import "WHBKHelpNaviController.h"
#import "UINavigationBar+WHBKNavBar.h"
@interface WHBKHelpNaviController ()<UINavigationControllerDelegate>

@end

@implementation WHBKHelpNaviController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.delegate = self;
}

/**
 *  不带透明过度的导航控制器(不使用运行时机制) 可以删除掉UINavigationBar+WHBKNavBar分类文件
 *
 *  @param rootViewController     根控制器
 *  @param backgroundColor        导航栏背景色
 *  @param titileStr              导航栏的标题名称
 *  @param barButtonItemAttribute 导航栏barItem按钮的属性
 *  @param barTitleAttribute      导航栏标题的属性
 */
-(instancetype)initNoTransparentOverWithRootViewController:(UIViewController *)rootViewController andNaviBackgroundColor:(UIColor *)backgroundColor andTitle:(NSString *)titileStr andBarButtonItemAttribute:(NSDictionary *)barButtonItemAttribute andBarTitleAttribute:(NSDictionary *)barTitleAttribute{
    if(self = [super initWithRootViewController:rootViewController]){
        //设置竖行导航栏的背景图片,用于消除导航栏的透明过度
        [self.navigationBar setBackgroundImage:[UIImage new] forBarMetrics:UIBarMetricsDefault];
        UIView *navBarView = [[UIView alloc]initWithFrame:CGRectMake(0, -20, [UIScreen mainScreen].bounds.size.width, 64)];
        navBarView.backgroundColor = backgroundColor;
        [self.navigationBar insertSubview:navBarView atIndex:0];
        //设置barBtnItem
        UIBarButtonItem *appearance = [UIBarButtonItem appearance];
        [appearance setTitleTextAttributes:barButtonItemAttribute forState:UIControlStateNormal];
        //设置barTitle
        [self.navigationBar setTitleTextAttributes:barTitleAttribute];
        rootViewController.title = titileStr;
        [self.navigationBar setShadowImage:[UIImage new]];
    }
    return self;
}


///**
// *  不带透明过度的导航控制器(使用运行时机制)，需要配分UINavigationBar+WHBKNavBar分类文件
// *
// *  @param rootViewController     根控制器
// *  @param backgroundColor        导航栏背景色
// *  @param titileStr              导航栏的标题名称
// *  @param barButtonItemAttribute 导航栏barItem按钮的属性
// *  @param barTitleAttribute      导航栏标题的属性
// */
//-(instancetype)initNoTransparentOverWithRootViewController:(UIViewController *)rootViewController andNaviBackgroundColor:(UIColor *)backgroundColor andTitle:(NSString *)titileStr andBarButtonItemAttribute:(NSDictionary *)barButtonItemAttribute andBarTitleAttribute:(NSDictionary *)barTitleAttribute{
//    if(self = [super initWithRootViewController:rootViewController]){
//        //设置竖行导航栏的背景图片,用于消除导航栏的透明过度
//        [self.navigationBar setNavBarBackgroundColor:backgroundColor andTitleAttribute:barTitleAttribute andBarButtonItemAttribute:barButtonItemAttribute];
//        rootViewController.title = titileStr;
//    }
//    return self;
//}
//

/**
 *  带透明过度的导航控制器
 *
 *  @param rootViewController     根控制器
 *  @param backgroundColor        导航栏背景色
 *  @param titileStr              导航栏的标题名称
 *  @param barButtonItemAttribute 导航栏barItem按钮的属性
 *  @param barTitleAttribute      导航栏标题的属性
 */
-(instancetype)initTransparentOverithRootViewController:(UIViewController *)rootViewController andNaviBackgroundColor:(UIColor *)backgroundColor andTitle:(NSString *)titileStr andBarButtonItemAttribute:(NSDictionary *)barButtonItemAttribute andBarTitleAttribute:(NSDictionary *)barTitleAttribute{
    if(self = [super initWithRootViewController:rootViewController]){
        [self.navigationBar setBarTintColor:backgroundColor];
        UIBarButtonItem *appearance = [UIBarButtonItem appearance];
        [appearance setTitleTextAttributes:barButtonItemAttribute forState:UIControlStateNormal];
        [self.navigationBar setTitleTextAttributes:barTitleAttribute];
        rootViewController.title = titileStr;
    }
    return self;
}

/**
 *  当即将现实导航控制器种的VC的时，会掉用该方法
 */
- (void)navigationController:(UINavigationController *)navigationController willShowViewController:(UIViewController *)viewController animated:(BOOL)animated{

}


//push的时候会掉用这个方法
-(void)pushViewController:(UIViewController *)viewController animated:(BOOL)animated{
    if (self.viewControllers.count > 0) {
        //实质当前push的控制器是否在push过程中需要隐藏tabBar
//        viewController.hidesBottomBarWhenPushed = YES;
        
    }
    [super pushViewController:viewController animated:animated];
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
